package jp.agentec.sinaburocast.cache;

import jp.agentec.sinaburocast.entity.Test;
import jp.agentec.sinaburocast.service.TestService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InitMethod;
import org.seasar.framework.container.annotation.tiger.InstanceType;

/**
 * testキャッシュ用クラス
 *
 *
 * @author tsukada
 *
 */
@Component(instance=InstanceType.SINGLETON)
public class TestCache extends AbstractCache<Test> {
	private final Log logger= LogFactory.getLog(getClass());

	public TestService testService;
	
	@InitMethod
	public void init() {
		setCache("test_cache");
	}

	@Override
	protected Test findRawValue(Object... key) {
		Integer testId = (Integer)key[0];
		return testService.findById(testId);
	}

}
