/**
 *
 */
package jp.agentec.sinaburocast.form.admin.mail;

import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.upload.FormFile;
import org.seasar.framework.util.StringUtil;
import org.seasar.struts.annotation.Arg;
import org.seasar.struts.annotation.IntegerType;
import org.seasar.struts.annotation.Mask;
import org.seasar.struts.annotation.Maxlength;
import org.seasar.struts.annotation.Msg;
import org.seasar.struts.annotation.Required;

import jp.agentec.sinaburocast.common.SinaburoConstant.MailSendTypeStr;
import jp.agentec.sinaburocast.common.util.SinaburoViewUtil;

/**
 * @author kim-hs
 *
 */
public class MailRegistForm {

	public String clipboard;

	public String enqueteMailId;

    @Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailSubject"), target = "confirm" )
    @Maxlength(maxlength=256, msg=@Msg(key="errors.maxlength"), arg0=@Arg(key="labels.mailSubject"))
	public String subject;

    public String deliveryGroupId;

    @Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailBody"), target = "confirm" )
	public String mailBody;

	public String status;

	public String deliveryTargetType;

	@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.deliveryTargetMethod"), target = "confirm" )
	public String deliveryTargetMethod;

	public String deliveryDate;

	public String deliveryHour;

	public String deliveryMin;

	@Required(msg=@Msg(key="errors.required"), arg0=@Arg(key="labels.mailAddress"), target = "testMailSend" )
	@Mask(mask = "^[!-~]+@[!-~]+$",msg = @Msg(key = "errors.email"),arg0=@Arg(key="labels.testSend"), target = "testMailSend")
	public String testMail;

	public String sender;

	public String groupName;

	@IntegerType(msg=@Msg(key="errors.integer"), arg0=@Arg(key="labels.enqueteId"))
	public String enqueteId;

	public String enqueteName;

	public FormFile file;

	public String sendType = "0";

	public ActionMessages validate(){
		ActionMessages errors = new ActionMessages();

		if (sendType.equals(MailSendTypeStr.FILE_UPLOAD)) {
			if (enqueteId.equals("")) {
				errors.add("enqueteId", new ActionMessage(SinaburoViewUtil.getMessage("errors.E064"), false));
			}
			if (file.getFileName().equals("")) {
				errors.add("deliveryGroupId", new ActionMessage(SinaburoViewUtil.getMessage("errors.E065"), false));
			}
			if (!file.getFileName().toUpperCase().endsWith(".TSV")) {
				errors.add("deliveryGroupId", new ActionMessage(SinaburoViewUtil.getMessage("errors.E040"), false));
			}
		} else {
			if (deliveryGroupId.equals("")) {
				errors.add("deliveryGroupId", new ActionMessage(SinaburoViewUtil.getMessage("errors.E032"), false));
			}
//			if (deliveryTargetType.equals("")) {
//				errors.add("deliveryTargetType", new ActionMessage(SinaburoViewUtil.getMessage("errors.E066"), false));
//			}
		}

		if (deliveryTargetMethod.equals("0")) {
			if(StringUtil.isBlank(deliveryDate)) {
				errors.add("deliveryDate", new ActionMessage("時間指定の日付を選択してください。",false));
			}
			if(StringUtil.isBlank(deliveryHour)) {
				errors.add("deliveryHour", new ActionMessage("時間指定の時を選択してください。",false));
			}
			if(StringUtil.isBlank(deliveryMin)) {
				errors.add("deliveryMin", new ActionMessage("時間指定の分を選択してください。",false));
			}
		}

		return errors;
	}
}
